// MsgAppDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MsgApp.h"
#include "MsgAppDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define WM_VISPER	(WM_USER + 1)
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMsgAppDlg dialog



CMsgAppDlg::CMsgAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMsgAppDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMsgAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, outText);
}

BEGIN_MESSAGE_MAP(CMsgAppDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(WM_VISPER, OnVisper)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CMsgAppDlg message handlers

BOOL CMsgAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	strcpy(vocabulary[0],"Zero");
	strcpy(vocabulary[1],"One");
	strcpy(vocabulary[2],"Two");
	strcpy(vocabulary[3],"Three");
	strcpy(vocabulary[4],"Four");
	strcpy(vocabulary[5],"Five");
	strcpy(vocabulary[6],"Six");
	strcpy(vocabulary[7],"Seven");
	strcpy(vocabulary[8],"Eight");
	strcpy(vocabulary[9],"Nine");
	oldWord=-1;//

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMsgAppDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMsgAppDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMsgAppDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//Here Visper
LRESULT CMsgAppDlg::OnVisper (WPARAM wp, LPARAM lp)
{
	char tmp[1000];
	if(oldWord==lp)
		strcpy(tmp, " ");
	else
		strcpy(tmp, "\r\n");
	strcat(tmp, vocabulary[wp]);
	AddText(tmp);
	oldWord=lp;
	return 0;
}

int CMsgAppDlg::AddText(char *text)
{//by MP
	char buffer[16384];
	outText.GetWindowText (buffer, 16384);
	strcat (buffer, text);
	if (strlen(buffer) > 16000)
		outText.SetWindowText (buffer + strlen (buffer) - 16000);
	else
		outText.SetWindowText (buffer);
	outText.LineScroll (16384, 0);
	return 0;
}
